--Real Position Graphical Coverage Optimizer by Tritonio
--Copyright 2010-2011 Konstantinos Asimakis
--All rights reserved.
--The source is open but changes and redistribution are only allowed for non-commercial purposes.
--For commercial purposes you should contact me to obtain a license.
--
--Web:   http://www.inshame.com
--Email: inshame at gmail dot com
--       asimakis at ceid dot upatras dot gr
--
--Note to muggles: d = a and b or c
--in 99% of the cases does this: if a then d=b else d=c end
--Also this: d = a or b
--does this: if a then d=a else d=b end
--
--So distances are in meters.

-- NOTES FOR ME:
-- na thimatai se kathe metalaksi tin mexri tora diadromi kai na min metalasei pali toys idioys akironontas praktika tin metalaksi toys.
-- na apothikeyei kata to loading to plegmatos to poies kipseles einai geitonikes kathos kai tis metaksi toys apostaseis... To mexri poses kipseles tha thimatai gia kate kipseli tha orizetai apo to max_dist_that_matters. Diladi oses theoroynte geitonikes kai kpaoion aythereto tropo tha apothiketotal_yai metaksi toys mazi me tin apostasi poy tis xorizei.

--Here be constants!

--GUI constants
mouse_operation="optimizer"
screen_width,screen_height=500,500 --The screen will be this size.
border=20; --Border width in pixels.

--Debugging constants
--profiling_enabled=true --If you ever enable the profiler, it stops profiling and saves it's output if you right click. NO IT DOESN'T.
print_filer=io.open("stdoutr.txt","w")
print_file=io.open("stdout.txt","w")
print_file2=io.open("stdout2.txt","w")
print_file3=io.open("stdout3.txt","w")

--Optimization constans
X_factor=1 --Changes the aggressiveness of the mutation function.
halt=true --Start stopped.
metrics={}
for line in io.popen("dir /b metrics"):lines() do
	if string.find(line,"%.lua$") then dofile("metrics/"..line) end
end
optimize=next(metrics)
speedratio=10

--Natural constants
c=299792458

--No more constants from now on. It's an order.

if profiling_enabled then
	dofile("profiler.lua")
	profiler=newProfiler()
	profiler:start()
end


function printr(text)
	print_filer:write(text.."\n")
	print_filer:flush()
end
function my_print_x(text)
	print_file:write(text.."\n")
	print_file:flush()
end
function my_print_y1(text)
	print_file2:write(text.."\n")
	print_file2:flush()
end
function my_print_y2(text)
	print_file3:write(text.."\n")
	print_file3:flush()
end

function is_in_table(element,t)
	for i,v in pairs(t) do
		if element==v then return true end
	end
	return false
end

function db_to_ratio(db)
	return 10^(db/10)
end

-- XTNDL functions

function entity(tab)
	setmetatable(tab,{__index=function (entity,t) --Interpolation function.
		local known={}
		for known_time in pairs(entity) do if type(known_time)=="number" then table.insert(known,known_time) end end
		table.sort(known)
		if t<known[1] or t>known[#known] then return false end
		for i=1,#known-1 do
			local known_time=known[i]
			local next_known_time=known[i+1]
			print(known_time,next_known_time)
			if known_time<t and t<next_known_time then
				local res={}
				for variable_name in pairs(entity[known_time]) do
					if next_known_time==math.huge then
						res[variable_name]=entity[known_time][variable_name]
					else
						res[variable_name]=(entity[known_time][variable_name]*(next_known_time-t)+entity[next_known_time][variable_name]*(t-known_time))/(next_known_time-known_time)
					end
				end
				return res
			end
		end
	end})
	return tab
end

world={users={},cells={}}
function world:new()
	local new={}
	setmetatable(new,{__index=self})
	return new
end

function world:calculate_size()
	self.min_x,self.min_y,self.max_x,self.max_y=math.huge,math.huge,-math.huge,-math.huge
	for i,user in pairs(self.users) do
		for timestamp,pos in pairs(user) do
			if type(timestamp)=="number" then
				self.min_x,self.min_y,self.max_x,self.max_y=math.min(self.min_x,pos.x),math.min(self.min_y,pos.y),math.max(self.max_x,pos.x),math.max(self.max_y,pos.y)
			end
		end
	end
	for i,cell in pairs(self.cells) do
		self.min_x,self.min_y,self.max_x,self.max_y=math.min(self.min_x,cell.x),math.min(self.min_y,cell.y),math.max(self.max_x,cell.x),math.max(self.max_y,cell.y)
	end
	self.width=self.max_x-self.min_x
	self.height=self.max_y-self.min_y
end

function world:create_user(x,y,t)
	local new_user=entity{[t]={x=x,y=y}}
	local user_obj={max_time=t,user_data=new_user}
	setmetatable(user_obj,{__index=user})
	table.insert(self.users,new_user)
	return user_obj
end

function world:create_user_group(x,y,c,r,t)
	local user_group_obj={users={},r=r}
	for i=1,c do
		table.insert(user_group_obj.users,world:create_user(x+math.random()*r*2-r,y+math.random()*r*2-r,t))   --THIS SHOULD BE A CIRCLE. FIX IT.
	end
	setmetatable(user_group_obj,{__index=user_group})
	return user_group_obj
end

user={}
function user:move_to(x,y,dt)
	self.user_data[self.max_time+dt]={x=x,y=y}
	self.max_time=self.max_time+dt
end

user_group={}
function user_group:move_to(x,y,dt)
	for i,user in pairs(self.users) do
		user:move_to(x+math.random()*self.r*2-self.r,y+math.random()*self.r*2-self.r,dt)
	end
end

-- End of XTNDL funcitons

--yparxei mia sigxisi ston kodika sxetika me to an ta userindex prepei na einai arithmoi h otidipote value. Kalo tha itan na ta kano opos skopeya na mporoyn na einai otidipote alla tote tmimata tipoy: #topology.users h #world.users tha stamatisoyn na doyleboyn. Opote thelei kapoion kodika na kanei katametrisi kai na bazei to apotelesma se kapoia metabliti.

function hash(something) --H PAIRS EDO EINAI OK? NA TO DOKIMASO MIPOS THELEI IPAIRS. EXO LOGO!
	local ret=0
	if type(something)=="table" then
		for i,v in pairs(something) do
			ret=(ret+(1+hash(v))*(1+hash(i)))%123456789123
		end
	elseif type(something)=="number" then
		ret=(ret+something+2)%123456789123
	elseif type(something)=="string" then
		for i,v in pairs{string.byte(something,1,-1)} do
			ret=(ret+((3+v)*i))%123456789123
		end
	end
	return ret
end
	
function load_XTNDL(filename) --It just executes the topology file. It could use some sandboxing in the future but it's not needed in this phase.
	dofile(filename)
	world:calculate_size()
end

function table_to_string(t,depth,used)
	used=used or {}
	local output={}
	depth=depth or 0
	local tabs=string.rep("\t",depth)
	table.insert(output,tabs.."{ ("..tostring(t)..")\n")
	if used[t] then
		table.insert(output,tabs.."\tAlready printed\n")
	else
		used[t]=true
		for i,v in pairs(t) do
			table.insert(output,tabs.."\t[")
			if type(i)=="table" then
				table.insert(output,"\n"..table_to_string(i,depth+2,used).."\n")
				table.insert(output,tabs.."\t]")
			elseif type(i)=="string" then
				table.insert(output,'"'..tostring(i)..'"]')
			elseif type(i)=="function" then
				table.insert(output,'"'..tostring(i)..(used[v] and " Already used " or "")..'"]')
				used[i]=true
			else
				table.insert(output,tostring(i).."]")
			end
			table.insert(output," = ")
			if type(v)=="table" then
				table.insert(output,"\n"..table_to_string(v,depth+2,used))
			elseif type(v)=="string" then
				table.insert(output,'"'..tostring(v)..'"')
			elseif type(v)=="function" then
				table.insert(output,tostring(v)..(used[v] and " Already used" or ""))
				used[v]=true
			else
				table.insert(output,tostring(v))
			end
			table.insert(output,",\n")
		end
	end
	table.insert(output,tabs.."}")
	return table.concat(output)
end

function round(digits,...) --It rips the space-time continuum. (Especially when run in LuaJIT)
	for i=1,arg.n do
		arg[i]=math.floor(arg[i]*10^digits+0.5)/10^digits
	end
	return unpack(arg)
end

function screen_to_grid(x,y) --Converts screen coordinates to real coordinates.
	return (x-border)*world.width/(screen_width-2*border)+world.min_x,(y-border)*world.height/(screen_height-2*border-100)+world.min_y
end

function grid_to_screen(x,y) --Converts real coordinates to screen coordinates.
	return (x-world.min_x)/world.width*(screen_width-border*2)+border,(y-world.min_y)/world.height*(screen_height-border*2-100)+border
end

function copy_topology(topology,dont_copy_techs) --Copies a topology, replicating the cell_techs part while just "linking" to the users and cells parts which are huge and constant.
	local new_topology={}
	for i,v in pairs(topology) do
		if i=="cell_techs" then 
			if dont_copy_techs then
				new_topology[i]={}
			else
				new_topology[i]=copy_table(v)
			end
		elseif i=="score" or i=="text" then
			
		else
			new_topology[i]=v
		end
	end
	return new_topology
end

function copy_table(t) --Creates table replicas. Will only work with non table indexes. No need to worry though, only lua-psychos use tables as index values.
	local new={}
	for i,v in pairs(t) do
		new[i]=(type(v)=="table" and copy_table(v) or v)
	end
	return new
end

function clip(n,low,high) --Clips a number between two others
	return math.min(math.max(n,low),high)
end

function love.mousepressed(mouse_x,mouse_y,button)
	local true_x,true_y=screen_to_grid(mouse_x,mouse_y)
	if mouse_operation=="user" then
		if button=="m" then
			mouse_operation="cell"
		end
	elseif mouse_operation=="cell" then
		if button=="m" then
			mouse_operation="optimizer"
		end
	elseif mouse_operation=="optimizer" then
		if button=="l" then
			optimize=next(metrics,optimize) or next(metrics)
		end
		if button=="wu" then
			showing=showing%population+1
		end
		if button=="wd" then
			showing=(showing+population-2)%population+1
		end
		if button=="r" then
			halt=(not halt) --Halts the optimization.
		end
		if button=="m" then
			mouse_operation="user"
		end
	end
end

function love.keypressed(key,unicode)
	--[[
	if key=="=" then
		local true_x,true_y=screen_to_grid(love.mouse.getPosition())
		local closest_distance,winner=math.huge
		for cell_index,cell in pairs(world.cells) do
			local distance=(cell.x-true_x)^2+(cell.y-true_y)^2 --Squared distance to be exact...
			if distance<closest_distance then
				closest_distance=distance
				winner=cell_index
			end
		end
		lastpower,world.cell_techs[winner].power=world.cell_techs[winner].power,lastpower
		metrics[optimize].sanitize(world)
		metrics[optimize].evaluate(world)
	end
	if key=="-" then
		local true_x,true_y=screen_to_grid(love.mouse.getPosition())
		local closest_distance,winner=math.huge
		for cell_index,cell in pairs(world.cells) do
			local distance=(cell.x-true_x)^2+(cell.y-true_y)^2 --Squared distance to be exact...
			if distance<closest_distance then
				closest_distance=distance
				winner=cell_index
			end
		end
		lastpower=world.cell_techs[winner].power
		world.cell_techs[winner].power=0.0005
		metrics[optimize].sanitize(world)
		metrics[optimize].evaluate(world)
	end
	--]]
	if key=="d" then
		my_print("\n\n\n-------------------\n\n\n")
		my_print(table_to_string(_G))
	end
	if key=="c" then
		collectgarbage()
	end
	if key=="p" then
		if profiling_enabled then
			profiler:stop()
			local outfile = io.open( "profile.txt", "w+" )
			profiler:report( outfile )
			outfile:close()
		end
	end
	if key=="w" then
		h=io.open("users_output.txt","w")
		for user_index,user in ipairs(world.users) do
			h:write(user.x.." "..user.y.."\n")
		end
		h:close()
		h=io.open("cells_output.txt","w")
		for cell_index,cell in ipairs(world.cells) do
			h:write(cell.x.." "..cell.y.."\n")
		end
		h:close()
	end
end

function love.load()
	math.randomseed(os.time())
	timestamp=0
	--local map_x,map_y,meters_per_pixel=string.match(io.open("map.txt"):read(),"([%d%.%-]+)%s+([%d%.%-]+)%s+([%d%.%-]+)")
	--map={x=tonumber(map_x),y=tonumber(map_y),meters_per_pixel=tonumber(meters_per_pixel),image=love.graphics.newImage("map.bmp")}
	load_XTNDL("positions.txt") --OTAN THA GINEI SANDBOXED THE PREPEI NA EPISTREFEI TO WORLD KAI NA TO BAZO ME = STIN GLOBAL METABLITI.
	metrics[optimize].sanitize(world)
	metrics[optimize].evaluate(world,timestamp)
	tries=0
	phase=0
	love.graphics.setMode( screen_width, screen_height, false, true, 0 )
	love.graphics.setBackgroundColor(255,255,255)
	love.graphics.setColor(0,0,0)
	printr(table_to_string(world))
end

function love.draw()
	love.graphics.setCaption("DAGraCO by Tritonio ("..math.floor(collectgarbage("count")/1024+0.5).."MB)")
	--map_on_screen_x,map_on_screen_y=grid_to_screen(map.x,map.y)
	love.graphics.setColor(255,255,255,255)
	--love.graphics.draw(map.image,map_on_screen_x,map_on_screen_y,0, (screen_width-2*border) * map.meters_per_pixel / world.width, (screen_height-2*border-100) * map.meters_per_pixel / world.height)
	for cell_index,cell in pairs(world.cells) do
		for _,user_index in pairs(world.cell_techs[cell_index].user_indexes) do
			local user=world.users[user_index]
			if user[timestamp] then
				local color={R=200,G=200,B=200}
				local screen_user_x,screen_user_y=grid_to_screen(user[timestamp].x,user[timestamp].y)
				local screen_cell_x,screen_cell_y=grid_to_screen(cell.x,cell.y)
				love.graphics.setColor(color.R,color.G,color.B)
				love.graphics.line(screen_user_x,screen_user_y,screen_cell_x,screen_cell_y)
			end
		end
		local color=metrics[optimize].get_color(world.cell_techs[cell_index])
		local screen_cell_x,screen_cell_y=grid_to_screen(cell.x,cell.y)
		local vertices={
			screen_cell_x-1,	screen_cell_y-6;
			screen_cell_x+1,	screen_cell_y-6;
			screen_cell_x+6,	screen_cell_y-12;
			screen_cell_x-6,	screen_cell_y-12;
			
			screen_cell_x-1,	screen_cell_y-6;
		}
		love.graphics.setColor(color.R,color.G,color.B)
		love.graphics.polygon("fill",vertices)
		local vertices={
			screen_cell_x-1,	screen_cell_y-6;
			screen_cell_x-1,	screen_cell_y;
			screen_cell_x+1,	screen_cell_y;
			screen_cell_x+1,	screen_cell_y-6;
			
			screen_cell_x-1,	screen_cell_y-6;
		}
		love.graphics.setColor(color.R,color.G,color.B)
		love.graphics.polygon("fill",vertices)
	end
	for user_index,user in pairs(world.users) do
		if user[timestamp] then
			for i=1,3 do
				local cell_index=user.signal[i].cell_index
				local color={R=200,G=100,B=100}
				local screen_user_x,screen_user_y=grid_to_screen(user[timestamp].x,user[timestamp].y)
				local screen_cell_x,screen_cell_y=grid_to_screen(world.cells[cell_index].x,world.cells[cell_index].y)
				love.graphics.setColor(color.R,color.G,color.B)
				love.graphics.line(screen_user_x,screen_user_y,screen_cell_x,screen_cell_y)
			end
			local color={R=128,G=128,B=128}
			local screen_user_x,screen_user_y=grid_to_screen(user[timestamp].x,user[timestamp].y)
			local vertices={
				screen_user_x-2,	screen_user_y;
				screen_user_x,		screen_user_y-2;
				screen_user_x+2,	screen_user_y;
				screen_user_x,		screen_user_y+2;
				
				screen_user_x-2,	screen_user_y;
			}
			love.graphics.setColor(color.R,color.G,color.B)
			love.graphics.polygon("fill",vertices)
			--love.graphics.setColor(0,0,0)
			--love.graphics.polygon("line",vertices)
		end
	end
	--[[
	love.graphics.print(tries.." tries.\nShowing: "..(overlay and "1-" or "")..showing.."/"..population.."\nScore: "..round(4,world.evaluation.RE).."\nMBSFN/total: "..world.evaluation.total_MBSFN.."/"..world.evaluation.total_transmitting.."\nMy Ratio: "..round(6,world.evaluation.myratio).."\n",25,screen_height-90)
	love.graphics.setColor(0,0,255)
	love.graphics.print("MBSFN",screen_width-150,screen_height-90)
	love.graphics.setColor(0,255,255)
	love.graphics.print("Assisting",screen_width-150,screen_height-75)
	love.graphics.setColor(255,0,0)
	love.graphics.print("PTM",screen_width-150,screen_height-60)
	love.graphics.setColor(0,0,0)
	--]]
	
	local true_mouse_x,true_mouse_y=screen_to_grid(love.mouse.getPosition())
	local closest_distance,winner=math.huge
	for cell_index,cell in pairs(world.cells) do
		local distance=(cell.x-true_mouse_x)^2+(cell.y-true_mouse_y)^2 --Squared distance to be exact...
		if distance<closest_distance then
			closest_distance=distance
			winner=cell_index
		end
	end
	last_cell_text=metrics[optimize].get_tech_text(world.cell_techs[winner])
	
	love.graphics.setColor(0,0,0)
	love.graphics.print(timestamp.." seconds.\n".."Mouse operation: "..mouse_operation.."\nOptimizing: "..optimize.."\n"..world.text.."\n"..(last_cell_text or ""),border,screen_height-100)
	local info_messages
	if mouse_operation=="user" then
		info_messages={
			"Left click: Place",
			"Right click: Remove",
			"Middle click: Switch mode",
			"O: Overlay subjects",
			"D: Dump subjects to file",
			"C: Collect garbage",
			"W: Write topology to file",
		}
	elseif mouse_operation=="cell" then
		info_messages={
			"Left click: Place",
			"Right click: Remove",
			"Middle click: Switch mode",
			"O: Overlay subjects",
			"C: Collect garbage",
			"W: Write topology to file",
		}
	elseif mouse_operation=="optimizer" then
		info_messages={
			"Left click: Change optimization metric",
			"Right click: Start/Stop optimization",
			"Middle click: Switch mode",
			"Wheel up: Next subject",
			"Wheel down: Previous subject",
			"O: Overlay subjects",
			"D: Dump subjects to file",
			"W: Write topology to file",
		}
	end
	local info_text
	if #info_messages>5 then
		local starting_point=(#info_messages>4 and math.floor(os.time()/3) or 0)
		info_text=
			info_messages[starting_point%#info_messages+1].."\n"..
			info_messages[(starting_point+1)%#info_messages+1].."\n"..
			info_messages[(starting_point+2)%#info_messages+1].."\n"..
			info_messages[(starting_point+3)%#info_messages+1].."\n"..
			info_messages[(starting_point+4)%#info_messages+1].."\n"
	else
		info_text=table.concat(info_messages,"\n")
	end
	love.graphics.print("Instructions:\n"..info_text,screen_width-250,screen_height-100)
end


function love.update(dt)
	if not halt then
		tries=tries+1
		timestamp=timestamp+dt*speedratio
		--local hashes={}
		--for subject_index=protected_population,1,-1 do
		--for subject_index=protected_population,1,-1 do
		--	table.insert(hashes,hash(subjects[subject_index].cell_techs))
		--end
		--for subject_index=population,protected_population+1,-1 do --For the unprotected ones... (we suppose the list is sorted)
		--	if math.random()<probability_to_crossbreed then
		--		subjects[subject_index]=metrics[optimize].crossbreed(subjects[subject_index],subjects[math.random(1,math.min(subject_index,population-discarded_population))])
		--	else
		--		subjects[subject_index]=copy_topology(subjects[math.random(1,math.min(subject_index,population-discarded_population))])
		--	end
		if phase==0 then
			metrics[optimize].evaluate(world,timestamp)
			world.old_score=world.score
			world.old_cell_techs=copy_table(world.cell_techs)
			metrics[optimize].mutate(world,X_factor)
			--my_print(tries.."\t"..world.score.." "..old_score.." ".. (old_score>world.score and "WORSE" or "BETTER").. " " ..world.acceptable.." "..world.power)
			phase=1
		elseif phase==1 then
			metrics[optimize].evaluate(world,timestamp)
			if world.old_score>world.score then
				world.cell_techs=world.old_cell_techs
				--world.score=old_score
				phase=0
			else
				world.old_score=world.score
				world.old_cell_techs=copy_table(world.cell_techs)
				metrics[optimize].mutate(world,X_factor)
				phase=1
			end
		end
		--my_print(tries.."\t"..world.power.."\t"..world.acceptable) --### OUT OF MODEL ###--
		--energy=(energy or 0)+dt*world.power
		--scoresum=(scoresum or 0)+world.score
		--failmeter=(failmeter or 0)+dt*(#world.users-world.acceptable)
		--my_print_x(world.power..","..world.score..","..world.acceptable..","..world.power) --### OUT OF MODEL ###--
		my_print_x(timestamp)
		my_print_y1(world.power)
		my_print_y2(world.acceptable)
	end
end